﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Windows;
using System.Windows.Controls;
using System.Windows.Data;
using System.Windows.Documents;
using System.Windows.Input;
using System.Windows.Media;
using System.Windows.Media.Imaging;
using System.Windows.Navigation;
using System.Windows.Shapes;
using Telerik.Windows.Controls;
using Telerik.Windows.Data;

namespace ColumnGetAutoWidth
{
    /// <summary>
    /// Interaction logic for MainWindow.xaml
    /// </summary>
    public partial class MainWindow : Window
    {
        public MainWindow()
        {
            InitializeComponent();
        }

        List<double> columnWidths = new List<double>();

        private void RadButton_Click(object sender, RoutedEventArgs e)
        {
            SetWidth(playersGrid);
        }
        private void RadButton2_Click(object sender, RoutedEventArgs e)
        {
            GetWidth(playersGrid);
        }

        private void RadButton_ClickEmpty(object sender, RoutedEventArgs e)
        {
            SetWidth(playersGridEmpty);
        }
        private void RadButton2_ClickEmpty(object sender, RoutedEventArgs e)
        {
            GetWidth(playersGridEmpty);
        }

        private void SetWidth(RadGridView grid)
        {
            columnWidths.Clear();

            foreach (var column in grid.Columns)
            {
                column.Width = GridViewLength.Auto;
                grid.ScrollIntoView(null, column);
                // playersGrid.UpdateLayout();
                // column.Width = column.ActualWidth;
                // column.IsSelected = true;
                // column.Focus();
                // column.Width = column.ActualWidth;
                columnWidths.Add(column.ActualWidth);
            }

            grid.ScrollIntoView(null, grid.Columns[0]);
        }



        private void GetWidth(RadGridView grid)
        {
            var actualWitdhs = new List<double>();

            foreach (var column in grid.Columns)
            {
                actualWitdhs.Add(column.ActualWidth);
            }

            MessageBox.Show(
                String.Join(Environment.NewLine, actualWitdhs) +
                Environment.NewLine /* +
                "vs" +
                Environment.NewLine +
                String.Join(Environment.NewLine, columnWidths) */);
        }
    }
}
